#include <nds.h>
#include <stdlib.h>
#include "../../common/command_codes.h"

#define SCHANNEL_WAVEDUTY(n) (n << 24)

u32 waveDutyCalc(u32 x)
{
	return (x << 24);
}

int vcount;
touchPosition first,tempPos;

//---------------------------------------------------------------------------------
void VcountHandler() {
//---------------------------------------------------------------------------------
	static int lastbut = -1;
	
	uint16 but=0, x=0, y=0, xpx=0, ypx=0, z1=0, z2=0;

	but = REG_KEYXY;

	if (!( (but ^ lastbut) & (1<<6))) {
 
		tempPos = touchReadXY();

		x = tempPos.x;
		y = tempPos.y;
		xpx = tempPos.px;
		ypx = tempPos.py;
		z1 = tempPos.z1;
		z2 = tempPos.z2;
		
	} else {
		lastbut = but;
		but |= (1 <<6);
	}

	if ( vcount == 80 ) {
		first = tempPos;
	} else {
		if (	abs( xpx - first.px) > 10 || abs( ypx - first.py) > 10 ||
				(but & ( 1<<6)) ) {

			but |= (1 <<6);
			lastbut = but;

		} else { 	
			IPC->mailBusy = 1;
			IPC->touchX			= x;
			IPC->touchY			= y;
			IPC->touchXpx		= xpx;
			IPC->touchYpx		= ypx;
			IPC->touchZ1		= z1;
			IPC->touchZ2		= z2;
			IPC->mailBusy = 0;
		}
	}
	IPC->buttons		= but;
	vcount ^= (80 ^ 130);
	SetYtrigger(vcount);

}



void playIfNonZero(int channel, int waveDuty, int data)
{
		if (data > 0)
		{
			SCHANNEL_CR(channel) = SOUND_VOL(100) | SOUND_PAN(64) | waveDutyCalc(waveDuty) | SOUND_FORMAT_PSG | SCHANNEL_ENABLE;
			SCHANNEL_TIMER(channel) = SOUND_FREQ(data << 3);
		}
		else
		{
			SCHANNEL_CR(channel) = SOUND_VOL(0) | SOUND_PAN(64) | waveDutyCalc(waveDuty) | SOUND_FORMAT_PSG | SCHANNEL_ENABLE;
		}
}


void fifoHandler()
{
	static int waveDuty = 3;
    static int droneEnabled = 0;

	while (!(REG_IPC_FIFO_CR & IPC_FIFO_RECV_EMPTY))
	{
		u32 command = REG_IPC_FIFO_RX;  
		u32 content = REG_IPC_FIFO_RX;

		if (command == COMMAND_WAVEDUTY_UP) { waveDuty++; continue; }
		if (command == COMMAND_WAVEDUTY_DOWN) { waveDuty--; continue; }

		if (command == COMMAND_TOGGLE_DRONE) 	
		{ 
            if (droneEnabled == 0) 
            {
                droneEnabled = 1;
            }
            else
            {
                droneEnabled = 0;
                playIfNonZero(9, 3, 0);                
            }
		}
		
		if (command == COMMAND_PLAY_NOTE_VOICE1) 	{ playIfNonZero(8, waveDuty, content); }
		
		if (droneEnabled == 1)
		{
                playIfNonZero(9, 3, 130);		
		}
		else
		{
                if (command == COMMAND_PLAY_NOTE_VOICE2) 	{ playIfNonZero(9, 3, content); }
		}
		if (command == COMMAND_PLAY_NOTE_VOICE3) 	{ playIfNonZero(10, 3, content);  }
		if (command == COMMAND_PLAY_NOTE_VOICE4) 	{ playIfNonZero(11, 3, content); }
	}
}
//---------------------------------------------------------------------------------
void VblankHandler(void) {
//---------------------------------------------------------------------------------
}

//---------------------------------------------------------------------------------
int main(int argc, char ** argv) {
//---------------------------------------------------------------------------------

	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_SEND_CLEAR;

	// Reset the clock if needed
	rtcReset();

	irqInit();
	irqSet(IRQ_VBLANK, VblankHandler);
	irqSet(IRQ_FIFO_NOT_EMPTY, fifoHandler); // Handle FIFO receives
	irqEnable(IRQ_FIFO_NOT_EMPTY);
	REG_IPC_FIFO_CR = IPC_FIFO_ENABLE | IPC_FIFO_RECV_IRQ;

	SetYtrigger(80);
	vcount = 80;
	irqSet(IRQ_VCOUNT, VcountHandler);
	irqEnable(IRQ_VBLANK);
	irqEnable(IRQ_VCOUNT);

    SOUND_CR = SOUND_VOL(100) | SOUND_ENABLE;

	// Wait for sound to come on by using 2 blanks.
    swiWaitForVBlank();             // Wait for sound to initialize, 1/2
    swiWaitForVBlank();             // Wait for sound to initialize, 2/2
	
	// Keep the ARM7 idle
	while (1) swiWaitForVBlank();
}


